#region Using declarations
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.ComponentModel.DataAnnotations;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Input;
using System.Windows.Media;
using System.Xml.Serialization;
using NinjaTrader.Cbi;
using NinjaTrader.Gui;
using NinjaTrader.Gui.Chart;
using NinjaTrader.Gui.SuperDom;
using NinjaTrader.Gui.Tools;
using NinjaTrader.Data;
using NinjaTrader.NinjaScript;
using NinjaTrader.Core.FloatingPoint;

#endregion



#region NinjaScript generated code. Neither change nor remove.

namespace NinjaTrader.NinjaScript.Indicators
{
	public partial class Indicator : NinjaTrader.Gui.NinjaScript.IndicatorRenderBase
	{
		
		private AdvancedADX[] cacheAdvancedADX;
		private AdvancedATR[] cacheAdvancedATR;
		private AdvancedBands[] cacheAdvancedBands;
		private AdvancedCCI[] cacheAdvancedCCI;
		private AdvancedDI[] cacheAdvancedDI;
		private AdvancedMACD[] cacheAdvancedMACD;
		private AdvancedRSI[] cacheAdvancedRSI;
		private AdvancedStochastics[] cacheAdvancedStochastics;
		private AdvancedVelocityIndexD1[] cacheAdvancedVelocityIndexD1;
		private AdvancedVelocityIndexD2[] cacheAdvancedVelocityIndexD2;
		private AdvancedVelocityIndexD3[] cacheAdvancedVelocityIndexD3;
		private AdvancedVelocityIndexD4[] cacheAdvancedVelocityIndexD4;

		
		public AdvancedADX AdvancedADX(int period)
		{
			return AdvancedADX(Input, period);
		}

		public AdvancedATR AdvancedATR(int period)
		{
			return AdvancedATR(Input, period);
		}

		public AdvancedBands AdvancedBands(double numStdDev, int period)
		{
			return AdvancedBands(Input, numStdDev, period);
		}

		public AdvancedCCI AdvancedCCI(int period)
		{
			return AdvancedCCI(Input, period);
		}

		public AdvancedDI AdvancedDI(int period)
		{
			return AdvancedDI(Input, period);
		}

		public AdvancedMACD AdvancedMACD(int fast, int slow, int smooth)
		{
			return AdvancedMACD(Input, fast, slow, smooth);
		}

		public AdvancedRSI AdvancedRSI(int period, int smooth)
		{
			return AdvancedRSI(Input, period, smooth);
		}

		public AdvancedStochastics AdvancedStochastics(int periodD, int periodK, int smooth)
		{
			return AdvancedStochastics(Input, periodD, periodK, smooth);
		}

		public AdvancedVelocityIndexD1 AdvancedVelocityIndexD1(int period, int smooth)
		{
			return AdvancedVelocityIndexD1(Input, period, smooth);
		}

		public AdvancedVelocityIndexD2 AdvancedVelocityIndexD2(int period, int smooth)
		{
			return AdvancedVelocityIndexD2(Input, period, smooth);
		}

		public AdvancedVelocityIndexD3 AdvancedVelocityIndexD3(int period, int smooth)
		{
			return AdvancedVelocityIndexD3(Input, period, smooth);
		}

		public AdvancedVelocityIndexD4 AdvancedVelocityIndexD4(int period, int smooth)
		{
			return AdvancedVelocityIndexD4(Input, period, smooth);
		}


		
		public AdvancedADX AdvancedADX(ISeries<double> input, int period)
		{
			if (cacheAdvancedADX != null)
				for (int idx = 0; idx < cacheAdvancedADX.Length; idx++)
					if (cacheAdvancedADX[idx].Period == period && cacheAdvancedADX[idx].EqualsInput(input))
						return cacheAdvancedADX[idx];
			return CacheIndicator<AdvancedADX>(new AdvancedADX(){ Period = period }, input, ref cacheAdvancedADX);
		}

		public AdvancedATR AdvancedATR(ISeries<double> input, int period)
		{
			if (cacheAdvancedATR != null)
				for (int idx = 0; idx < cacheAdvancedATR.Length; idx++)
					if (cacheAdvancedATR[idx].Period == period && cacheAdvancedATR[idx].EqualsInput(input))
						return cacheAdvancedATR[idx];
			return CacheIndicator<AdvancedATR>(new AdvancedATR(){ Period = period }, input, ref cacheAdvancedATR);
		}

		public AdvancedBands AdvancedBands(ISeries<double> input, double numStdDev, int period)
		{
			if (cacheAdvancedBands != null)
				for (int idx = 0; idx < cacheAdvancedBands.Length; idx++)
					if (cacheAdvancedBands[idx].NumStdDev == numStdDev && cacheAdvancedBands[idx].Period == period && cacheAdvancedBands[idx].EqualsInput(input))
						return cacheAdvancedBands[idx];
			return CacheIndicator<AdvancedBands>(new AdvancedBands(){ NumStdDev = numStdDev, Period = period }, input, ref cacheAdvancedBands);
		}

		public AdvancedCCI AdvancedCCI(ISeries<double> input, int period)
		{
			if (cacheAdvancedCCI != null)
				for (int idx = 0; idx < cacheAdvancedCCI.Length; idx++)
					if (cacheAdvancedCCI[idx].Period == period && cacheAdvancedCCI[idx].EqualsInput(input))
						return cacheAdvancedCCI[idx];
			return CacheIndicator<AdvancedCCI>(new AdvancedCCI(){ Period = period }, input, ref cacheAdvancedCCI);
		}

		public AdvancedDI AdvancedDI(ISeries<double> input, int period)
		{
			if (cacheAdvancedDI != null)
				for (int idx = 0; idx < cacheAdvancedDI.Length; idx++)
					if (cacheAdvancedDI[idx].Period == period && cacheAdvancedDI[idx].EqualsInput(input))
						return cacheAdvancedDI[idx];
			return CacheIndicator<AdvancedDI>(new AdvancedDI(){ Period = period }, input, ref cacheAdvancedDI);
		}

		public AdvancedMACD AdvancedMACD(ISeries<double> input, int fast, int slow, int smooth)
		{
			if (cacheAdvancedMACD != null)
				for (int idx = 0; idx < cacheAdvancedMACD.Length; idx++)
					if (cacheAdvancedMACD[idx].Fast == fast && cacheAdvancedMACD[idx].Slow == slow && cacheAdvancedMACD[idx].Smooth == smooth && cacheAdvancedMACD[idx].EqualsInput(input))
						return cacheAdvancedMACD[idx];
			return CacheIndicator<AdvancedMACD>(new AdvancedMACD(){ Fast = fast, Slow = slow, Smooth = smooth }, input, ref cacheAdvancedMACD);
		}

		public AdvancedRSI AdvancedRSI(ISeries<double> input, int period, int smooth)
		{
			if (cacheAdvancedRSI != null)
				for (int idx = 0; idx < cacheAdvancedRSI.Length; idx++)
					if (cacheAdvancedRSI[idx].Period == period && cacheAdvancedRSI[idx].Smooth == smooth && cacheAdvancedRSI[idx].EqualsInput(input))
						return cacheAdvancedRSI[idx];
			return CacheIndicator<AdvancedRSI>(new AdvancedRSI(){ Period = period, Smooth = smooth }, input, ref cacheAdvancedRSI);
		}

		public AdvancedStochastics AdvancedStochastics(ISeries<double> input, int periodD, int periodK, int smooth)
		{
			if (cacheAdvancedStochastics != null)
				for (int idx = 0; idx < cacheAdvancedStochastics.Length; idx++)
					if (cacheAdvancedStochastics[idx].PeriodD == periodD && cacheAdvancedStochastics[idx].PeriodK == periodK && cacheAdvancedStochastics[idx].Smooth == smooth && cacheAdvancedStochastics[idx].EqualsInput(input))
						return cacheAdvancedStochastics[idx];
			return CacheIndicator<AdvancedStochastics>(new AdvancedStochastics(){ PeriodD = periodD, PeriodK = periodK, Smooth = smooth }, input, ref cacheAdvancedStochastics);
		}

		public AdvancedVelocityIndexD1 AdvancedVelocityIndexD1(ISeries<double> input, int period, int smooth)
		{
			if (cacheAdvancedVelocityIndexD1 != null)
				for (int idx = 0; idx < cacheAdvancedVelocityIndexD1.Length; idx++)
					if (cacheAdvancedVelocityIndexD1[idx].Period == period && cacheAdvancedVelocityIndexD1[idx].Smooth == smooth && cacheAdvancedVelocityIndexD1[idx].EqualsInput(input))
						return cacheAdvancedVelocityIndexD1[idx];
			return CacheIndicator<AdvancedVelocityIndexD1>(new AdvancedVelocityIndexD1(){ Period = period, Smooth = smooth }, input, ref cacheAdvancedVelocityIndexD1);
		}

		public AdvancedVelocityIndexD2 AdvancedVelocityIndexD2(ISeries<double> input, int period, int smooth)
		{
			if (cacheAdvancedVelocityIndexD2 != null)
				for (int idx = 0; idx < cacheAdvancedVelocityIndexD2.Length; idx++)
					if (cacheAdvancedVelocityIndexD2[idx].Period == period && cacheAdvancedVelocityIndexD2[idx].Smooth == smooth && cacheAdvancedVelocityIndexD2[idx].EqualsInput(input))
						return cacheAdvancedVelocityIndexD2[idx];
			return CacheIndicator<AdvancedVelocityIndexD2>(new AdvancedVelocityIndexD2(){ Period = period, Smooth = smooth }, input, ref cacheAdvancedVelocityIndexD2);
		}

		public AdvancedVelocityIndexD3 AdvancedVelocityIndexD3(ISeries<double> input, int period, int smooth)
		{
			if (cacheAdvancedVelocityIndexD3 != null)
				for (int idx = 0; idx < cacheAdvancedVelocityIndexD3.Length; idx++)
					if (cacheAdvancedVelocityIndexD3[idx].Period == period && cacheAdvancedVelocityIndexD3[idx].Smooth == smooth && cacheAdvancedVelocityIndexD3[idx].EqualsInput(input))
						return cacheAdvancedVelocityIndexD3[idx];
			return CacheIndicator<AdvancedVelocityIndexD3>(new AdvancedVelocityIndexD3(){ Period = period, Smooth = smooth }, input, ref cacheAdvancedVelocityIndexD3);
		}

		public AdvancedVelocityIndexD4 AdvancedVelocityIndexD4(ISeries<double> input, int period, int smooth)
		{
			if (cacheAdvancedVelocityIndexD4 != null)
				for (int idx = 0; idx < cacheAdvancedVelocityIndexD4.Length; idx++)
					if (cacheAdvancedVelocityIndexD4[idx].Period == period && cacheAdvancedVelocityIndexD4[idx].Smooth == smooth && cacheAdvancedVelocityIndexD4[idx].EqualsInput(input))
						return cacheAdvancedVelocityIndexD4[idx];
			return CacheIndicator<AdvancedVelocityIndexD4>(new AdvancedVelocityIndexD4(){ Period = period, Smooth = smooth }, input, ref cacheAdvancedVelocityIndexD4);
		}

	}
}

namespace NinjaTrader.NinjaScript.MarketAnalyzerColumns
{
	public partial class MarketAnalyzerColumn : MarketAnalyzerColumnBase
	{
		
		public Indicators.AdvancedADX AdvancedADX(int period)
		{
			return indicator.AdvancedADX(Input, period);
		}

		public Indicators.AdvancedATR AdvancedATR(int period)
		{
			return indicator.AdvancedATR(Input, period);
		}

		public Indicators.AdvancedBands AdvancedBands(double numStdDev, int period)
		{
			return indicator.AdvancedBands(Input, numStdDev, period);
		}

		public Indicators.AdvancedCCI AdvancedCCI(int period)
		{
			return indicator.AdvancedCCI(Input, period);
		}

		public Indicators.AdvancedDI AdvancedDI(int period)
		{
			return indicator.AdvancedDI(Input, period);
		}

		public Indicators.AdvancedMACD AdvancedMACD(int fast, int slow, int smooth)
		{
			return indicator.AdvancedMACD(Input, fast, slow, smooth);
		}

		public Indicators.AdvancedRSI AdvancedRSI(int period, int smooth)
		{
			return indicator.AdvancedRSI(Input, period, smooth);
		}

		public Indicators.AdvancedStochastics AdvancedStochastics(int periodD, int periodK, int smooth)
		{
			return indicator.AdvancedStochastics(Input, periodD, periodK, smooth);
		}

		public Indicators.AdvancedVelocityIndexD1 AdvancedVelocityIndexD1(int period, int smooth)
		{
			return indicator.AdvancedVelocityIndexD1(Input, period, smooth);
		}

		public Indicators.AdvancedVelocityIndexD2 AdvancedVelocityIndexD2(int period, int smooth)
		{
			return indicator.AdvancedVelocityIndexD2(Input, period, smooth);
		}

		public Indicators.AdvancedVelocityIndexD3 AdvancedVelocityIndexD3(int period, int smooth)
		{
			return indicator.AdvancedVelocityIndexD3(Input, period, smooth);
		}

		public Indicators.AdvancedVelocityIndexD4 AdvancedVelocityIndexD4(int period, int smooth)
		{
			return indicator.AdvancedVelocityIndexD4(Input, period, smooth);
		}


		
		public Indicators.AdvancedADX AdvancedADX(ISeries<double> input , int period)
		{
			return indicator.AdvancedADX(input, period);
		}

		public Indicators.AdvancedATR AdvancedATR(ISeries<double> input , int period)
		{
			return indicator.AdvancedATR(input, period);
		}

		public Indicators.AdvancedBands AdvancedBands(ISeries<double> input , double numStdDev, int period)
		{
			return indicator.AdvancedBands(input, numStdDev, period);
		}

		public Indicators.AdvancedCCI AdvancedCCI(ISeries<double> input , int period)
		{
			return indicator.AdvancedCCI(input, period);
		}

		public Indicators.AdvancedDI AdvancedDI(ISeries<double> input , int period)
		{
			return indicator.AdvancedDI(input, period);
		}

		public Indicators.AdvancedMACD AdvancedMACD(ISeries<double> input , int fast, int slow, int smooth)
		{
			return indicator.AdvancedMACD(input, fast, slow, smooth);
		}

		public Indicators.AdvancedRSI AdvancedRSI(ISeries<double> input , int period, int smooth)
		{
			return indicator.AdvancedRSI(input, period, smooth);
		}

		public Indicators.AdvancedStochastics AdvancedStochastics(ISeries<double> input , int periodD, int periodK, int smooth)
		{
			return indicator.AdvancedStochastics(input, periodD, periodK, smooth);
		}

		public Indicators.AdvancedVelocityIndexD1 AdvancedVelocityIndexD1(ISeries<double> input , int period, int smooth)
		{
			return indicator.AdvancedVelocityIndexD1(input, period, smooth);
		}

		public Indicators.AdvancedVelocityIndexD2 AdvancedVelocityIndexD2(ISeries<double> input , int period, int smooth)
		{
			return indicator.AdvancedVelocityIndexD2(input, period, smooth);
		}

		public Indicators.AdvancedVelocityIndexD3 AdvancedVelocityIndexD3(ISeries<double> input , int period, int smooth)
		{
			return indicator.AdvancedVelocityIndexD3(input, period, smooth);
		}

		public Indicators.AdvancedVelocityIndexD4 AdvancedVelocityIndexD4(ISeries<double> input , int period, int smooth)
		{
			return indicator.AdvancedVelocityIndexD4(input, period, smooth);
		}
	
	}
}

namespace NinjaTrader.NinjaScript.Strategies
{
	public partial class Strategy : NinjaTrader.Gui.NinjaScript.StrategyRenderBase
	{
		
		public Indicators.AdvancedADX AdvancedADX(int period)
		{
			return indicator.AdvancedADX(Input, period);
		}

		public Indicators.AdvancedATR AdvancedATR(int period)
		{
			return indicator.AdvancedATR(Input, period);
		}

		public Indicators.AdvancedBands AdvancedBands(double numStdDev, int period)
		{
			return indicator.AdvancedBands(Input, numStdDev, period);
		}

		public Indicators.AdvancedCCI AdvancedCCI(int period)
		{
			return indicator.AdvancedCCI(Input, period);
		}

		public Indicators.AdvancedDI AdvancedDI(int period)
		{
			return indicator.AdvancedDI(Input, period);
		}

		public Indicators.AdvancedMACD AdvancedMACD(int fast, int slow, int smooth)
		{
			return indicator.AdvancedMACD(Input, fast, slow, smooth);
		}

		public Indicators.AdvancedRSI AdvancedRSI(int period, int smooth)
		{
			return indicator.AdvancedRSI(Input, period, smooth);
		}

		public Indicators.AdvancedStochastics AdvancedStochastics(int periodD, int periodK, int smooth)
		{
			return indicator.AdvancedStochastics(Input, periodD, periodK, smooth);
		}

		public Indicators.AdvancedVelocityIndexD1 AdvancedVelocityIndexD1(int period, int smooth)
		{
			return indicator.AdvancedVelocityIndexD1(Input, period, smooth);
		}

		public Indicators.AdvancedVelocityIndexD2 AdvancedVelocityIndexD2(int period, int smooth)
		{
			return indicator.AdvancedVelocityIndexD2(Input, period, smooth);
		}

		public Indicators.AdvancedVelocityIndexD3 AdvancedVelocityIndexD3(int period, int smooth)
		{
			return indicator.AdvancedVelocityIndexD3(Input, period, smooth);
		}

		public Indicators.AdvancedVelocityIndexD4 AdvancedVelocityIndexD4(int period, int smooth)
		{
			return indicator.AdvancedVelocityIndexD4(Input, period, smooth);
		}


		
		public Indicators.AdvancedADX AdvancedADX(ISeries<double> input , int period)
		{
			return indicator.AdvancedADX(input, period);
		}

		public Indicators.AdvancedATR AdvancedATR(ISeries<double> input , int period)
		{
			return indicator.AdvancedATR(input, period);
		}

		public Indicators.AdvancedBands AdvancedBands(ISeries<double> input , double numStdDev, int period)
		{
			return indicator.AdvancedBands(input, numStdDev, period);
		}

		public Indicators.AdvancedCCI AdvancedCCI(ISeries<double> input , int period)
		{
			return indicator.AdvancedCCI(input, period);
		}

		public Indicators.AdvancedDI AdvancedDI(ISeries<double> input , int period)
		{
			return indicator.AdvancedDI(input, period);
		}

		public Indicators.AdvancedMACD AdvancedMACD(ISeries<double> input , int fast, int slow, int smooth)
		{
			return indicator.AdvancedMACD(input, fast, slow, smooth);
		}

		public Indicators.AdvancedRSI AdvancedRSI(ISeries<double> input , int period, int smooth)
		{
			return indicator.AdvancedRSI(input, period, smooth);
		}

		public Indicators.AdvancedStochastics AdvancedStochastics(ISeries<double> input , int periodD, int periodK, int smooth)
		{
			return indicator.AdvancedStochastics(input, periodD, periodK, smooth);
		}

		public Indicators.AdvancedVelocityIndexD1 AdvancedVelocityIndexD1(ISeries<double> input , int period, int smooth)
		{
			return indicator.AdvancedVelocityIndexD1(input, period, smooth);
		}

		public Indicators.AdvancedVelocityIndexD2 AdvancedVelocityIndexD2(ISeries<double> input , int period, int smooth)
		{
			return indicator.AdvancedVelocityIndexD2(input, period, smooth);
		}

		public Indicators.AdvancedVelocityIndexD3 AdvancedVelocityIndexD3(ISeries<double> input , int period, int smooth)
		{
			return indicator.AdvancedVelocityIndexD3(input, period, smooth);
		}

		public Indicators.AdvancedVelocityIndexD4 AdvancedVelocityIndexD4(ISeries<double> input , int period, int smooth)
		{
			return indicator.AdvancedVelocityIndexD4(input, period, smooth);
		}

	}
}

#endregion
